default:
  image: docker:latest
  services:
    - docker:dind
  before_script:
    - docker info

stages:
  - test
  - build

eslint:
  stage: test
  variables:
    NODE_ENV: "test"
  script:
    - docker build --build-arg NPM_TOKEN=$NPM_TOKEN -t rcf-risor .
    - docker run -e NODE_ENV rcf-risor npm run eslint .

test:
  stage: test
  variables:
    NODE_ENV: "test"
  script:
    - docker build --build-arg NPM_TOKEN=$NPM_TOKEN -t rcf-risor .
    - docker run -e NODE_ENV rcf-risor npm run test

push docker:
  stage: build
  variables:
    NODE_ENV: "development"
  only:
    - dev
    - main
    - master
    - tags
  script:
    - docker build --target prod --build-arg NPM_TOKEN=$NPM_TOKEN --pull --cache-from $CI_REGISTRY_IMAGE:latest --tag $CI_REGISTRY_IMAGE:$CI_COMMIT_SHORT_SHA .
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker tag $CI_REGISTRY_IMAGE:$CI_COMMIT_SHORT_SHA $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_NAME
    - docker push $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_NAME
    - docker tag $CI_REGISTRY_IMAGE:$CI_COMMIT_SHORT_SHA $CI_REGISTRY_IMAGE:latest
    - docker push $CI_REGISTRY_IMAGE:latest
  interruptible: true
